/* structPointer.c
 * Demonstrate pointers to structures.
 */
#include <stdio.h>
#include <string.h>

#define NAME_SIZE 80

typedef struct {
  char last[NAME_SIZE];
  char first[NAME_SIZE];
  double gpa;
  int startYear;
} student_t;

void printRecord(student_t student);
void readRecord(student_t *student_p);

int main() {
  student_t student;

  readRecord(&student);
  printRecord(student);
  return 0;
}

void printRecord(student_t student) {
  printf("%s, %s: gpa:%f, year:%d\n",
      student.last, student.first,
      student.gpa, student.startYear);
}

void readRecord(student_t *student_p) {
  (*student_p).gpa = 3.5;
  (*student_p).startYear = 2000;
  strncpy((*student_p).first,
      "Jane", NAME_SIZE);
  strncpy((*student_p).last,
      "Programmer", NAME_SIZE);
}
