/* stack.h
 * A header file for a stack containing type
 * declarations and function prototypes.
 */
typedef struct stackElem {
  int value;
  struct stackElem* next_p;
} stackElem_t;

typedef struct {
  stackElem_t* top_p;
} stack_t;

int pop(stack_t* stack_p);
void push(stack_t* stack_p, int value);
int top(stack_t* stack_p);
stack_t* newStack(void);
int empty(stack_t* stack_p);
